//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "MixKeyWins1.h"
#include "Mixmaster.h"
#include "fileman.h"
//---------------------------------------------------------------------------
#pragma link "explbtn"
#pragma resource "*.dfm"
TMixKeyWin1 *MixKeyWin1;
#define ENABLE true
const AnsiString MRINGTXT = mringtxt;
//---------------------------------------------------------------------------
// TMixKey
//---------------------------------------------------------------------------
__fastcall TMixKey::TMixKey()
   : TStringList()
{
   enabled = true;
}
//---------------------------------------------------------------------------
__fastcall TMixKey::TMixKey(TMixKey *key)
   : TStringList()
{
   enabled = key->enabled;
   Text = key->Text;
}
//---------------------------------------------------------------------------
__fastcall TMixKey::TMixKey(TStrings *key, bool Enabled)
   : TStringList()
{
   enabled = Enabled;
   Text = key->Text;
}
//---------------------------------------------------------------------------
__fastcall TMixKey::~TMixKey()
{
}
//---------------------------------------------------------------------------
AnsiString __fastcall TMixKey::ShortName()
{
   if (Count>0) return GetToken(0,Strings[0]," ");
   return "";
}
//---------------------------------------------------------------------------
AnsiString __fastcall TMixKey::EAddress()
{
   if (Count>0) return GetToken(1,Strings[0]," ");
   return "";
}
//---------------------------------------------------------------------------
AnsiString __fastcall TMixKey::KeyId()
{
   if (Count>0) return GetToken(2,Strings[0]," ");
   return "";
}
//---------------------------------------------------------------------------
AnsiString __fastcall TMixKey::Version()
{
   if (Count>0) return GetToken(3,Strings[0]," ");
   return "";
}
//---------------------------------------------------------------------------
AnsiString __fastcall TMixKey::Caps()
{
   if (Count>0) return GetToken(4,Strings[0]," ");
   return "";
}
//---------------------------------------------------------------------------
// TMixKeyList
//---------------------------------------------------------------------------
__fastcall TMixKeyList1::TMixKeyList1()
   : TStringList()
{
   type2 = new TStringList();
   GetType2(type2);
   Sorted = true;
   shrtLen = 0;
   addrLen = 0;
}
//---------------------------------------------------------------------------
__fastcall TMixKeyList1::TMixKeyList1(AnsiString filename)
   : TStringList()
{
   type2 = new TStringList();
   GetType2(type2);
   Sorted = true;
   shrtLen = 0;
   addrLen = 0;
   LoadFromFile(filename);
}
//---------------------------------------------------------------------------
__fastcall TMixKeyList1::TMixKeyList1(TMixKeyList1 *keys)
   : TStringList()
{
   type2 = new TStringList();
   GetType2(type2);
   Sorted = true;
   shrtLen = 0;
   addrLen = 0;
   versLen = 0;
   AddKeys(keys);
}
//---------------------------------------------------------------------------
__fastcall TMixKeyList1::TMixKeyList1(TStrings *keys)
   : TStringList()
{
   type2 = new TStringList();
   GetType2(type2);
   Sorted = true;
   shrtLen = 0;
   addrLen = 0;
   versLen = 0;
   AddKeys(keys);
}
//---------------------------------------------------------------------------
__fastcall TMixKeyList1::TMixKeyList1(TMixKey *key)
   : TStringList()
{
   type2 = new TStringList();
   GetType2(type2);
   Sorted = true;
   shrtLen = 0;
   addrLen = 0;
   versLen = 0;
   AddKey(key);
}
//---------------------------------------------------------------------------
__fastcall TMixKeyList1::~TMixKeyList1()
{
}
//---------------------------------------------------------------------------
void __fastcall TMixKeyList1::GetType2(TStrings *Type2)
{
   if (FileExists(mtyp2txt))
      Type2->LoadFromFile(mtyp2txt);
}
//---------------------------------------------------------------------------
void __fastcall TMixKeyList1::SaveToFileBak(AnsiString &docname, int bakcopies)
{
   TMixKey *key;
   AnsiString desc;
   TStringList *keys = new TStringList();
   type2->Clear();

   for (int i=0; i<Count; i++)
   {
      key = MixKey(i);
      if (!key || !key->Count) continue;
      keys->Add(key->Text+"\n");
      type2->Add((key->enabled?"":"#")+key->Strings[0]);
   }
   for (int i=bakcopies; i>=1; i--)
   {
      if (FileExists(bak(docname,i))) DeleteFile(bak(docname,i).c_str());
      if (FileExists(bak(docname,i-1)))
          rename(bak(docname,i-1).c_str(),bak(docname,i).c_str());
   }
   if (bakcopies && FileExists(docname))
      rename(docname.c_str(),bak(docname,1).c_str());

   type2->SaveToFile(mtyp2txt);
   keys->SaveToFile(docname);
   delete keys;
}
//---------------------------------------------------------------------------
void __fastcall TMixKeyList1::LoadFromFile(AnsiString filename)
{
   Clear();
   TStringList *keys = new TStringList();
   if (FileExists(filename)) keys->LoadFromFile(filename);
   AddKeys(keys);
   delete keys;
}
//---------------------------------------------------------------------------
TMixKey* __fastcall TMixKeyList1::MixKey(int atPos)
{
   if (atPos<0 || atPos>=Count) return NULL;
   return (TMixKey*)Objects[atPos];
}
//---------------------------------------------------------------------------
int __fastcall TMixKeyList1::AddKeys(TMixKeyList1 *keys)
{
   int c=0;
   for (int i=0; i<keys->Count; i++)
   {
      AddKey(keys->MixKey(i));
      c++;
   }
   return c;
}
//---------------------------------------------------------------------------
int __fastcall TMixKeyList1::AddKeys(TStrings *keys)
{
   int c=0;
   AnsiString keydesc,desc;
   TStringList *key=new TStringList();
   TStringList *KEYS=new TStringList();
   KEYS->AddStrings(keys);
   while (MixGetNextKey(keydesc,key,KEYS))
   {
      AddKey(key);
      c++;
   }
   delete KEYS;
   delete key;
   return c;
}
//---------------------------------------------------------------------------
bool __fastcall TMixKeyList1::AddKey(TStrings *key)
{
   if (!MixKeyDefinately(key)) return false;
   TMixKey *KEY = new TMixKey(key);
   AddKey(KEY);
   delete KEY;
   return true;
}
//---------------------------------------------------------------------------
bool __fastcall TMixKeyList1::AddKey(TMixKey *key)
{
   if (!MixKeyDefinately(key)) return false;

   TMixKey *KEY = new TMixKey(key);
   
   AnsiString line = KEY->Strings[0];
   int pos = line.Pos(" ");
   line.Insert(s("           ").SubString(1,11-pos),pos);
   KEY->enabled = type2->IndexOf("#"+line)<0;
   
   AnsiString shrt=KEY->name,addr=KEY->address,vers=KEY->version;
   AddObject(shrt+","+addr+","+KEY->keyid+","+vers+","+KEY->caps,KEY);
   if (shrt.Length()>shrtLen) shrtLen = shrt.Length();
   if (addr.Length()>addrLen) addrLen = addr.Length();
   if (vers.Length()>versLen) versLen = vers.Length();
   return true;
}
//---------------------------------------------------------------------------
AnsiString __fastcall TMixKeyList1::KeyDescription(int atPos)
{
   if (atPos<0 || atPos>=Count) return "";
   addrLen = 31;
   AnsiString desc,addr;
   TStringList *flds = new TStringList();
   flds->CommaText = Strings[atPos];

   addr = PadRight(flds->Strings[1],addrLen);
   if (addr[addrLen]!=' ') addr = addr.SubString(1,addrLen-3)+"...";

   desc = PadRight(flds->Strings[0],shrtLen)+"  "+addr+"  "+flds->Strings[2]+"  "+
      PadRight(flds->Strings[3],versLen)+"  "+flds->Strings[4];
   delete flds;
   return desc;
}
//---------------------------------------------------------------------------
AnsiString __fastcall TMixKeyList1::ShortName(int atPos)
{
   if (atPos<0 || atPos>=Count) return "";
   AnsiString shrt = GetParam(0,Strings[atPos],",");
   return shrt;
}
//---------------------------------------------------------------------------
AnsiString __fastcall TMixKeyList1::EAddress(int atPos)
{
   if (atPos<0 || atPos>=Count) return "";
   return GetParam(1,Strings[atPos],",");
}
//---------------------------------------------------------------------------
AnsiString __fastcall TMixKeyList1::Version(int atPos)
{
   if (atPos<0 || atPos>=Count) return "";
   return GetParam(2,Strings[atPos],",");
}
//---------------------------------------------------------------------------
AnsiString __fastcall TMixKeyList1::KeyId(int atPos)
{
   if (atPos<0 || atPos>=Count) return "";
   return GetParam(3,Strings[atPos],",");
}
//---------------------------------------------------------------------------
AnsiString __fastcall TMixKeyList1::Caps(int atPos)
{
   if (atPos<0 || atPos>=Count) return "";
   return GetParam(4,Strings[atPos],",");
}
//---------------------------------------------------------------------------
// TMixKeyWin
//---------------------------------------------------------------------------
__fastcall TMixKeyWin1::TMixKeyWin1(TComponent* Owner)
	: TForm(Owner)
{
   initdone = false;
   keys = new TMixKeyList1();
   newkeys = new TStringList();
   diskeys = new TStringList();
   keynodes = new TList();
   checksave = true;
   curkey = -1;
   SetHelpBtnPos();
   SetNothingSelected(); SaveBtn->Enabled = RefreshBtn->Enabled = false;
   cap = Caption; Caption = "Loading...";
   hidedisabled = GetAppIni("MixHideDisabled","0")=="1";
   bmpHideDis = new Graphics::TBitmap(); ImageList2->GetBitmap(0,bmpHideDis);
   bmpShowAll = new Graphics::TBitmap(); ImageList2->GetBitmap(1,bmpShowAll);
   HideDisBtn->Bitmap->Assign(hidedisabled?bmpHideDis:bmpShowAll);
   Timer1->Enabled = true;
}
//---------------------------------------------------------------------------
void __fastcall TMixKeyWin1::Timer1Timer(TObject *Sender)
{
   Timer1->Enabled = false;
   LoadKeys(); GenTreeView();
   initdone = true;
   Caption = cap;
}
//---------------------------------------------------------------------------
__fastcall TMixKeyWin1::~TMixKeyWin1()
{
   MixKeyWin1 = NULL;
}
//---------------------------------------------------------------------------
void __fastcall TMixKeyWin1::LoadKeys()
{
   keys->Clear();
   if (FileExists(MRINGTXT)) keys->LoadFromFile(MRINGTXT);
   modified = false;
}
//---------------------------------------------------------------------------
void __fastcall TMixKeyWin1::SetHelpBtnPos()
{
   HelpBtn->Left = Width-58;
   HideDisBtn->Left = HelpBtn->Left-(HideDisBtn->Width+1);
}
//---------------------------------------------------------------------------
void __fastcall TMixKeyWin1::SetNothingSelected()
{
   RequestBtn->Enabled = false;
   EnableDisableBtn(false);
   DeleteBtn->Enabled = false;
   curkey = -1;
   SetCount();
}
//---------------------------------------------------------------------------
void __fastcall TMixKeyWin1::SetCount(bool clear)
{
   AnsiString cur,count;
   if (Application->Terminated) return;
   if (!clear && WindowState!=wsMinimized && keys->Count)
   {
      cur = curkey>=0 ? s(curkey+1)+"/" : s("");
      count = cur+s(keys->Count);
   }
   AppMainForm->Perform(WM_SHOWSTATUS,1,(LPARAM)count.c_str());
}
//---------------------------------------------------------------------------
void __fastcall TMixKeyWin1::SetTreeItemBold(TTreeNode *ANode, bool Value,
   TTreeView *ATree)
{
   TTVItem item;
   int Template;
   if (!ANode) return;

   Template = Value ? -1 : 0;
   item.mask = TVIF_STATE;
   item.hItem = (HTREEITEM)ANode->ItemId;
   item.stateMask = TVIS_BOLD;
   item.state = item.stateMask & Template;
   TreeView_SetItem(ATree->Handle,&(TV_ITEM)item);
}
//---------------------------------------------------------------------------
void __fastcall TMixKeyWin1::GenTreeView()
{
   keynodes->Clear();
   SetRedraw(TreeView,0);
   TTreeNode *node,*cnode;
   TreeView->Items->Clear();

   TStringList *next=new TStringList();
   TreeView->Items->BeginUpdate();
   for (int i=0; i<keys->Count; i++)
   {
      TMixKey *KEY = keys->MixKey(i);
      AnsiString keydesc = keys->KeyDescription(i);
      node = TreeView->Items->AddChildObject(TreeView->Selected,keydesc,KEY);

      node->ImageIndex = KEY->enabled ? 0:1;
      node->SelectedIndex = node->ImageIndex;

      if (newkeys->IndexOf(node->Text)>=0) SetTreeItemBold(node,true,TreeView);
      keynodes->Add(node);

      keydesc = KEY->Strings[0];
      cnode=TreeView->Items->AddChild(node,"Name    : "+GetParam(0,keydesc," "));
      cnode->ImageIndex = -1; cnode->SelectedIndex = -1;
      cnode=TreeView->Items->AddChild(node,"Address : "+GetParam(1,keydesc," "));
      cnode->ImageIndex = -1; cnode->SelectedIndex = -1;
      cnode=TreeView->Items->AddChild(node,"Key-Id  : "+GetParam(2,keydesc," "));
      cnode->ImageIndex = -1; cnode->SelectedIndex = -1;
      cnode=TreeView->Items->AddChild(node,"Version : "+GetParam(3,keydesc," "));
      cnode->ImageIndex = -1; cnode->SelectedIndex = -1;
      cnode=TreeView->Items->AddChild(node,"Caps    : "+GetParam(4,keydesc," "));
      cnode->ImageIndex = -1; cnode->SelectedIndex = -1;
   }
   TreeView->Items->EndUpdate();
   RECT r = { 0,0,4096,4096 };
   InvalidateRect(TreeView->Handle,&r,false);
   delete next;
}
//---------------------------------------------------------------------------
void __fastcall TMixKeyWin1::EnableDisableBtn(bool enable)
{
   Graphics::TBitmap *bitmap=DisableBtn->Bitmap;
   TCanvas *canvas=bitmap->Canvas;
   SetRedraw(DisableBtn,0);
   if (enable)
   {
      for (int h=0; h<bitmap->Height; h++)
         for (int w=0; w<bitmap->Width; w++)
            if (canvas->Pixels[w][h]==clBlack) canvas->Pixels[w][h] = clBlue;
   }
   else
   {
      for (int h=0; h<bitmap->Height; h++)
         for (int w=0; w<bitmap->Width; w++)
            if (canvas->Pixels[w][h]==clBlue) canvas->Pixels[w][h] = clBlack;
   }
   DisableBtn->Enabled = enable;
   SetRedraw(DisableBtn,1);
}
//---------------------------------------------------------------------------
void __fastcall TMixKeyWin1::FormClose(TObject *Sender, TCloseAction &Action)
{
   Action = caFree;
}
//---------------------------------------------------------------------------
void __fastcall TMixKeyWin1::FormResize(TObject *Sender)
{
   SetHelpBtnPos();
}
//---------------------------------------------------------------------------