//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#include <filectrl.hpp>
#pragma hdrstop

#include "qspgpver.h"
#include "pgprecipdlgs.h"
#include "qspgppass.h"
#include "pgpbuffers.h"
#include "PgpPassEx.h"
#include "PgpFiles.h"
#include "PgpMsg.h"
#include "global.h"
#include "fileman.h"
#include "headman.h"
#include "pgpdlgs.h"
#include "MixmastDlg.h"
#include "pgpdb.h"
#include "view.h"

// REMEMBER: ActMainForm is the actual QS main form and must be used
// as, ActMainForm->Handle, in all MsgBoxes

USERES("QSPGP.res");
USEFORM("PgpRecipDlgs.cpp", PgpRecipForm);
USEFORM("PgpPassEx.cpp", PgpPassForm);
USEFORM("MixmastDlg.cpp", MixForm);
USEFORM("PgpDlgs.cpp", PgpDlg);
USEFORM("View.cpp", ViewDlg);
USEUNIT("PGPbuffers.cpp");
USEUNIT("Mixmaster.cpp");
USEUNIT("Fmxutils.cpp");
USEUNIT("QSpgpVer.cpp");
USEUNIT("Console.cpp");
USEUNIT("FileMan.cpp");
USEUNIT("HeadMan.cpp");
USEUNIT("PgpFiles.cpp");
USEUNIT("Global.cpp");
USEUNIT("PgpMsg.cpp");
USEUNIT("pgpdb.cpp");
USEUNIT("pgp.cpp");
USELIB("zlib.LIB");
USEDATAMODULE("QSpgpPass.cpp", Passphrase);
USEFORM("WipeDlgs.cpp", WipeDlg);
//---------------------------------------------------------------------------
extern "C" __declspec(dllexport) void __fastcall PgpInit(HINSTANCE HMixLib,
   HINSTANCE HSSLLib, TForm *MainForm, HWND AppHandle);
extern "C" __declspec(dllexport) void  __fastcall PgpShutDown();

extern "C" __declspec(dllexport) char* __fastcall GetPgpLibVersion();
extern "C" __declspec(dllexport) char* __fastcall GetPgpLibName();

extern "C" __declspec(dllexport) char* __fastcall PgpSignMessage(char *Message);
extern "C" __declspec(dllexport) char* __fastcall PgpEncryptMessage(char *Message);
extern "C" __declspec(dllexport) char* __fastcall PgpEncryptSignMessage(char *Message);
extern "C" __declspec(dllexport) char* __fastcall PgpDecryptVerifyMessage(char *Message, bool ForceDialog);
extern "C" __declspec(dllexport) char* __fastcall PgpVerifyMessage(char *Message);
extern "C" __declspec(dllexport) bool  __fastcall PgpIsConventional(char *Message);
extern "C" __declspec(dllexport) char* __fastcall PgpArmorBlockToArmorKeysCpk(char *BigBlock);
extern "C" __declspec(dllexport) bool  __fastcall PgpGetEncryptList(TForm *Owner,
   TStrings *Recips, bool CanConv);

// passphrase dialogs
//extern "C" __declspec(dllexport) char* __fastcall PGPgetConventionalPassphrase(TForm *Owner, AnsiString &Phrase);
//extern "C" __declspec(dllexport) char* __fastcall PGPgetDecryptionPassphrase(AnsiString &Phrase, TForm *MainForm);
//extern "C" __declspec(dllexport) char* __fastcall PGPgetSecretKeyPassphrase(AnsiString &UserId, AnsiString &Phrase,
//   TForm *MainForm);
// Keys is a list of key ids, current key tells dialog which to make current. After
// call current key indicated the key the phrase belongs to.
//extern "C" __declspec(dllexport) char* __fastcall PGPgetSignKeyIDAndPassphrase(TStrings *Keys, int &CurrentKey,
//   AnsiString &Phrase, TForm* MainForm);
// on entry CancelMode tells dialog to show 'clear secure mode' button. on exit it
// tells if the user wants to cancel secure mode.
//extern "C" __declspec(dllexport) char* __fastcall PGPgetSecureModePassphrase(bool &CancelMode, AnsiString &Phrase);


//---------------------------------------------------------------------------
char *retbuf=NULL;
//---------------------------------------------------------------------------
int WINAPI DllEntryPoint(HINSTANCE hinst, unsigned long reason, void*)
{
  return 1;
}
//---------------------------------------------------------------------------
void  __fastcall PgpInit(HINSTANCE HMixLib, HINSTANCE HSSLLib, TForm *MainForm,
   HWND AppHandle)
{
   Passphrase = new TPassphrase(NULL);
   hMixLib=HMixLib; hSSLLib=HSSLLib;
   Application->Handle=AppHandle;
   ActMainForm=MainForm;
}
//---------------------------------------------------------------------------
void __fastcall PgpShutDown()
{
   delete Passphrase;
}
//---------------------------------------------------------------------------
char* __fastcall GetPgpLibName()
{
   return AppName.c_str();
}
//---------------------------------------------------------------------------
char* __fastcall GetPgpLibVersion()
{
   return ReleaseVer.c_str();
}
//---------------------------------------------------------------------------
bool __fastcall CutMessageAtCutmarks(TStrings *msg)
{
   bool cut = false;
   if (msg->Text.Pos("\r\n"+CutMarks+"\r\n"))
   {
      while (msg->Count)
      {
         AnsiString line = msg->Strings[msg->Count-1];
         msg->Delete(msg->Count-1);
         if (line.TrimRight()==CutMarks) break;
      }
      cut = true;
   }
   while (msg->Count && msg->Strings[msg->Count-1].IsEmpty())
      msg->Delete(msg->Count-1);
   return cut;
}
//---------------------------------------------------------------------------
bool __fastcall InType1(AnsiString &remailer, TStrings *type1)
{
   bool ok = false;
   for (int i=0; i<type1->Count; i++)
   {
      if (type1->Strings[i]==remailer)// || type->Strings[i]=="#"+remailer)
      {
         ok = true;
         break;
      }
   }
   return ok;
}
//---------------------------------------------------------------------------
bool __fastcall GenShortList(TStrings *list)
{
   AnsiString line,tmp;
   TStringList *lines = new TStringList();
   for (int i=0; i<list->Count; i++)
   {
      tmp = list->Strings[i];
      if (tmp.Pos("$remailer{")!=1) continue;
      line = GetParam(1,tmp,"<"); line = GetParam(0,line,">");
      line += "="+GetParam(1,tmp,"\"");
      lines->Add(line);
   }
   list->Text = lines->Text;
   delete lines;
   return list->Count>0;
}
//---------------------------------------------------------------------------
bool __fastcall CpkGenShortList(TStrings *list)
{
   TStringList *clist = new TStringList();
   TStringList *alist = new TStringList();
   clist->Duplicates = dupIgnore; clist->Sorted = true;
   GetAppData(alist,CpunkShorts); clist->AddStrings(alist);
   int c=clist->Count;

   if (FileExists(clisttxt)) alist->LoadFromFile(clisttxt);
   GenShortList(alist); clist->AddStrings(alist);

   if (FileExists(clisttmp)) alist->LoadFromFile(clisttmp);
   GenShortList(alist); clist->AddStrings(alist);

   // check for new entries to save
   if (c<clist->Count) PutAppData(CpunkShorts,clist);

   list->AddStrings(clist);
   delete alist;
   delete clist;
   return list->Count>0;
}
//---------------------------------------------------------------------------
char* __fastcall PgpArmorBlockToArmorKeysCpk(char *BigBlock)
{
   TStringList *newlist = new TStringList();
   newlist->Duplicates=dupIgnore; newlist->Sorted = true;

   TStringList *cpklist = new TStringList();
   CpkGenShortList(cpklist);

   TStringList *bigblock = new TStringList(); bigblock->SetText(BigBlock);
   if (retbuf) delete retbuf; retbuf = NULL;

   TPgpDB *pgpdb = new TPgpDB(bigblock);
   delete bigblock;

   TStringList *keyblocks = new TStringList();
   pgpdb->SaveToStringsCpk(keyblocks,cpklist);
   if ((retbuf=new char[keyblocks->Text.Length()+1])!=NULL)
      strcpy(retbuf,keyblocks->Text.c_str());
   delete keyblocks;

   delete cpklist;
   delete pgpdb;
   return retbuf;
}
//---------------------------------------------------------------------------
bool __fastcall GetEncryptKeyidsFromPgpHdr(TStrings *msg, TStrings *keyids)
{
   keyids->Clear();
   TPGPbuffer *key = new TPGPbuffer();
   TPGPbuffer *pubs = new TPGPbuffer(PgpPublicRing(),NO_DISABLED);
   TPGPbuffer *cpks = new TPGPbuffer(PgpRemailRing(),NO_DISABLED);

   TStringList *cmds = new TStringList();
   THeaderManager *hm = new THeaderManager(msg);
   AnsiString id,ids,cmd,keyid,hdr = hm->GetDat(PgpHdr);
   if (hdr.IsEmpty()) hm->GetDat(PgpButtonsHdr);
   int i=0; while((cmd=GetToken(i++,hdr,";"))!="")
      cmds->Add(cmd.Trim());
   ids = cmds->Values["encrypt"];
   i=0; while((id=GetToken(i++,ids,","))!="")
      keyids->Add(id);
   delete cmds;
   delete hm;
   
   for (int i=0; i<keyids->Count; i++)
   {
      keyid = keyids->Strings[i].SubString(1,10);
      if (pubs->get(keyid,key) || cpks->get(keyid,key))
         keyids->Strings[i] = keyid+" "+key->firstuid;
   }

   delete cpks;
   delete pubs;
   delete key;
   return keyids->Count>0;
}
//---------------------------------------------------------------------------
bool __fastcall GetSignKeyidFromPgpHdr(TStrings *msg, AnsiString &keyid,
   AnsiString &passphrase)
{
   TStringList *cmds = new TStringList();
   THeaderManager *hm = new THeaderManager(msg);
   AnsiString id,ids,cmd,hdr = hm->GetDat(PgpHdr);
   if (hdr.IsEmpty()) hm->GetDat(PgpButtonsHdr);
   int i=0; while((cmd=GetToken(i++,hdr,";"))!="")
      cmds->Add(cmd.Trim());
   ids = cmds->Values["sign"];
   keyid = GetToken(0,ids,",");
   passphrase = Passphrase->Get(keyid);
   delete cmds;
   delete hm;
   return !keyid.IsEmpty();
}
//---------------------------------------------------------------------------
char* __fastcall PgpEncryptMessage(char *Message)
{
   TStringList *msg = new TStringList(); msg->SetText(Message);
   if (retbuf) delete retbuf; retbuf = NULL;

   CutMessageAtCutmarks(msg);
   if (!msg->Count)
   {
      MsgBoxHwnd(ActMainForm->Handle,
         s("Your message appears empty! Nothing to encrypt!"),
        "QS PGP Encrypt Error",
         MB_OK
      );
      delete msg;
      return NULL;
   }
   int idx=0; while (idx<msg->Count && !msg->Strings[idx].Trim().IsEmpty())
       idx++;
   if (idx==msg->Count)// || !msg->Strings[idx].TrimRight().IsEmpty())
   {
      MsgBoxHwnd(ActMainForm->Handle,
         s("Your message does not appear to have a body--or maybe\n")+
         s("there is not an empty line between headers and body\n\n")+
         s("Nothing to encrypt!"),
         "QS Encrypt Error",MB_OK);
      delete msg;
      return NULL;
   }
   // remove headers and hold for later
   TStringList *mail = new TStringList();
   while (msg->Count>idx+1)
   {
      mail->Add(msg->Strings[idx+1]);
      msg->Delete(idx+1);
   }
   if (!mail->Count)
   {
      MsgBoxHwnd(ActMainForm->Handle,
         s("Your message appears empty! Nothing to encrypt!"),
        "QS Encrypt Error",
         MB_OK
      );
      delete msg;
      return NULL;
   }

   bool needids;
   AnsiString passphrase,keyid,sigid;
   TStringList *recips = new TStringList();
   GetEncryptKeyidsFromPgpHdr(msg,recips); needids = recips->Count==0;

   THeaderManager *Headers = new THeaderManager(msg);
   if (needids) Headers->GetRecipsFull("To: ",recips,msg);
   delete Headers;

   if (needids && !PGPgetEncryptList(recips))
   {
      delete recips;
      delete msg;
      return NULL;
   }

   bool cEncrypt = recips->Text==UseConventional+"\r\n";
   if (cEncrypt && !PGPGETConventionalPassphrase(ActMainForm,passphrase))
   {
      delete recips;
      delete msg;
      return NULL;
   }

   int result;
   TPgpDlg *Pgp = new TPgpDlg(PgpPublicRing(),PgpSecretRing(),PgpRemailRing(),ActMainForm);
   if (cEncrypt) result = Pgp->EncryptCMessage(mail,passphrase);
   else result = Pgp->EncryptMessage(mail,recips);
   delete Pgp;

   if (result==PGP_OK)
   {
      msg->AddStrings(mail); mail->Clear();
      if ((retbuf=new char[msg->Text.Length()+1])!=NULL)
         strcpy(retbuf,msg->Text.c_str());
   }

   ClearString(passphrase);
   delete recips;
   delete mail;
   delete msg;
   return retbuf;
}
//---------------------------------------------------------------------------
char* __fastcall PgpSignMessage(char *Message)
{
   TStringList *msg = new TStringList(); msg->SetText(Message);
   if (retbuf) delete retbuf; retbuf = NULL;
   CutMessageAtCutmarks(msg);
   if (!msg->Count)
   {
      MsgBoxHwnd(ActMainForm->Handle,
         s("Your message appears empty! Nothing to sign!"),
        "QS PGP Encrypt Error",
         MB_OK
      );
      delete msg;
      return NULL;
   }

   int idx=0; while (idx<msg->Count && !msg->Strings[idx].Trim().IsEmpty())
       idx++;
   if (idx==msg->Count)
   {
      MsgBoxHwnd(ActMainForm->Handle,
         s("Your message does not appear to have a body--or maybe\n")+
         s("there is not an empty line between headers and body\n\n")+
         s("Nothing to sign!"),
        "QS PGP Encrypt Error",
         MB_OK
      );
      delete msg;
      return NULL;
   }

   AnsiString idtext8,sigid;
   TPGPbuffer *key = new TPGPbuffer();
   TStringList *keys = new TStringList();
   TStringList *uids = new TStringList();
   TPGPbuffer *seckeys = new TPGPbuffer(PgpSecretRing());
   while (key->copykeyfrom(seckeys,REWIND))
   {
      if (SecretKeyPacket(key->CTB))
      {
         idtext8 = key->idtext8;
         key->getuserids(uids);
         for (int i=0; i<uids->Count; i++)
            keys->Add("0x"+idtext8+" "+uids->Strings[i]);
      }
      key->clear();
   }
   delete seckeys;
   delete uids;
   delete key;

   if (!keys->Count)
   {
      MsgBoxHwnd(ActMainForm->Handle,
         "No keys found!","QS PGP Error",MB_OK);
      delete keys;
      delete msg;
      return NULL;
   }

   AnsiString passphrase,keyid;
   GetSignKeyidFromPgpHdr(msg,keyid,passphrase);
   sigid = keyid;

   THeaderManager *Headers = new THeaderManager(msg);
   if (keyid.IsEmpty()) keyid = Headers->GetDat("From: ");
   TStringList *recips = new TStringList();
   Headers->GetRecipsFull("To: ",recips);
   delete Headers;

   int current=-1;
   for (int i=0; i<keys->Count; i++)
   {
      if (keys->Strings[i].Pos(keyid)>0)
      {
         if (keys->Strings[i].Pos("0x")==1)
            sigid = keys->Strings[i].SubString(1,10);
         current = i;
         break;
      }
   }
   if (current>=0 && passphrase.IsEmpty()) passphrase = Passphrase->Get(sigid);
   if (passphrase.IsEmpty() && // maybe passphrase from cache?
      !PGPGETSignKeyIDAndPassphrase(ActMainForm,keys,current,passphrase))
   {
      delete recips;
      delete keys;
      delete msg;
      return NULL;
   }

   if (current>=0 && current<keys->Count)
   {
      keyid = keys->Strings[current].SubString(12,128);
      sigid = keys->Strings[current].SubString(3,8);
   }
   else
   {
      MsgBoxHwnd(ActMainForm->Handle,
         "No signing key selected.","PGP Error",MB_OK);
      delete recips;
      delete keys;
      delete msg;
      return NULL;
   }
   keyid = GetEAddress(keyid);
   // there is no need to transfer body to separate list as
   // the pgp sign cleartext takes the whole message--headers and body
   TPgpDlg *Pgp = new TPgpDlg(PgpPublicRing(),PgpSecretRing(),PgpRemailRing(),ActMainForm);
   Pgp->ToRemailer = Pgp->IsRemailed(recips); // to test for remailer address
                                  // added sigid later fo tmpsecring file
   int result = Pgp->SignMessage(msg,keyid,passphrase,&sigid);
   delete Pgp;

   if (result==PGP_OK && (retbuf=new char[msg->Text.Length()+1])!=NULL)
   {
      Passphrase->Add(sigid,passphrase);
      strcpy(retbuf,msg->Text.c_str());
   }

   ClearString(passphrase);
   delete recips;
   delete keys;
   delete msg;
   return retbuf;
}
//---------------------------------------------------------------------------
char* __fastcall PgpEncryptSignMessage(char *Message)
{
   AnsiString passphrase,keyid,sigid;
   TStringList *msg = new TStringList();
   msg->SetText(Message);

   bool needids;
   TStringList *recips = new TStringList();
   GetEncryptKeyidsFromPgpHdr(msg,recips); needids = recips->Count==0;
   GetSignKeyidFromPgpHdr(msg,keyid,passphrase); sigid = keyid;
   THeaderManager *Headers = new THeaderManager(msg);
   if (keyid.IsEmpty()) keyid=Headers->GetDat("From: ");
   if (needids) Headers->GetRecipsFull("To: ",recips,msg);
   delete Headers;

   if (retbuf) delete retbuf; retbuf = NULL;
   // get list of public keys
   if (needids && !PGPgetEncryptList(recips,NotConventional))
   {
      delete recips;
      delete msg;
      return NULL;
   }

   // open keyrings for signing key
   AnsiString idtext8;
   TPGPbuffer *key = new TPGPbuffer();
   TStringList *keys = new TStringList();
   TStringList *uids = new TStringList();
   TPGPbuffer *seckeys = new TPGPbuffer(PgpSecretRing());
   while (key->copykeyfrom(seckeys,REWIND))
   {
      if (SecretKeyPacket(key->CTB))
      {
         idtext8 = key->idtext8;
         key->getuserids(uids);
         for (int i=0; i<uids->Count; i++)
            keys->Add("0x"+idtext8+" "+uids->Strings[i]);
      }
      key->clear();
   }
   delete seckeys;
   delete uids;
   delete key;

   // fail job if no secret keys
   if (!keys->Count)
   {
      MsgBoxHwnd(ActMainForm->Handle,
         "No keys found!","QS PGP Error",MB_OK);
      delete recips;
      delete keys;
      delete msg;
      return NULL;
   }

   // pause
   Application->ProcessMessages(); Sleep(200);
   // keys ok, get sign key and passphrase
   int current=-1;
   for (int i=0; i<keys->Count; i++)
   {
      if (keys->Strings[i].Pos(keyid)>0)
      {
         if (keys->Strings[i].Pos("0x")==1)
            sigid = keys->Strings[i].SubString(1,10);
         current = i;
         break;
      }
   }
   if (current>=0 && passphrase.IsEmpty()) passphrase = Passphrase->Get(sigid);
   if (passphrase.IsEmpty() && // got passphrase from cache already ?
      !PGPGETSignKeyIDAndPassphrase(ActMainForm,keys,current,passphrase))
   {
      delete recips;
      delete keys;
      delete msg;
      return NULL;
   }
   if (current>=0 && current<keys->Count)
   {
      keyid = keys->Strings[current];
      sigid = keyid.SubString(1,10);
   }
   keyid = GetEAddress(keyid);

   // prepare message
   CutMessageAtCutmarks(msg);
   if (!msg->Count)
   {
      MsgBoxHwnd(ActMainForm->Handle,
         s("Your message appears empty! Nothing to sign!"),
        "QS PGP Encrypt Error",
         MB_OK
      );
      ClearString(passphrase);
      delete recips;
      delete keys;
      delete msg;
      return NULL;
   }
   int idx=0; while (idx<msg->Count && !msg->Strings[idx].TrimRight().IsEmpty())
       idx++;
   if (idx==msg->Count)
   {
      MsgBoxHwnd(ActMainForm->Handle,
         s("Your message does not appear to have a body--or maybe\n")+
         s("there is not an empty line between headers and body\n\n")+
         s("Nothing to encrypt!"),
         "QS PGP Encrypt Error",MB_OK);
      ClearString(passphrase);
      delete recips;
      delete keys;
      delete msg;
      return NULL;
   }
   TStringList *mail = new TStringList();
   while (msg->Count>idx+1)
   {
      mail->Add(msg->Strings[idx+1]);
      msg->Delete(idx+1);
   }
   if (!mail->Count)
   {
      MsgBoxHwnd(ActMainForm->Handle,
         s("Your message appears empty! Nothing to sign!"),
        "QS PGP Encrypt Error",
         MB_OK
      );
      ClearString(passphrase);
      delete recips;
      delete keys;
      delete msg;
      return NULL;
   }
   TPgpDlg *Pgp = new TPgpDlg(PgpPublicRing(),PgpSecretRing(),PgpRemailRing(),ActMainForm);
   int result = Pgp->EncryptSignMessage(mail,keyid,passphrase,recips,&sigid);
   delete Pgp;

   if (result==PGP_OK)
   {
      msg->AddStrings(mail); mail->Clear();
      if ((retbuf=new char[msg->Text.Length()+1])!=NULL)
         strcpy(retbuf,msg->Text.c_str());
      Passphrase->Add(sigid,passphrase);
   }
   ClearString(passphrase);
   delete mail;
   delete keys;
   delete recips;
   delete msg;
   return retbuf;
}
//---------------------------------------------------------------------------
bool __fastcall PgpIsConventional(char *Message)
{
   TPgpMsg *pgpmsg = new TPgpMsg(Message);
   bool is = pgpmsg->IsConventional();
   delete pgpmsg;
   return is;
}
//---------------------------------------------------------------------------
bool __fastcall GoodKeys(TStrings *keylist)
{
   bool good = false;
   for (int i=0; i<keylist->Count; i++)
      if (keylist->Strings[i].Pos("0x")>1)
      {
         good = true;
         break;
      }
   return good;
}
//---------------------------------------------------------------------------
char* __fastcall PgpDecryptVerifyMessage(char *Message, bool ForceDialog)
{
   TPgpDBKey *key;
   TPgpMsg *msg = new TPgpMsg(Message);
   if (msg->IsConventional())
   {
      delete msg;
      return IsConventionalEncr.c_str();
   }
   // get key for keyid of encrypt msg
   AnsiString userid;
   TStringList *id8s=new TStringList();
   TStringList *tmp=new TStringList();
   tmp->Text = msg->IdText8();
   for (int i=0; i<tmp->Count; i++)
      if (id8s->IndexOf(tmp->Strings[i])<0)
         id8s->Add(tmp->Strings[i]);
   delete tmp;

   TStringList *uids = new TStringList();
   TPgpDB *pgpdb = new TPgpDB(PgpSecretRing());
   for (int i=0; i<pgpdb->KeyCount(); i++)
   {
      key = pgpdb->GetKey(i);
      if (id8s->IndexOf(key->IdText8())>=0)
         uids->Add(key->KeyUserIds(0)+" 0x"+key->IdText8());
   }
   for (int i=0; i<id8s->Count; i++)
      if (!uids->Text.Pos("0x"+id8s->Strings[i]))
         uids->Add("0x"+id8s->Strings[i]);

   if (!GoodKeys(uids))
   {
      for (int i=0; i<id8s->Count; i++) id8s->Strings[i] = "0x"+id8s->Strings[i];
      MsgBoxHwnd(ActMainForm->Handle,
         s("Sorry, you do not have a secret key corresponding to any\n")+//required to\n")+
         s("of the public keys below.\n\n"+id8s->Text),
         "Can't Decrypt",
         MB_OK
      );
      delete pgpdb;
      delete id8s;
      delete msg;
      return NULL;
   }
   delete pgpdb;

   AnsiString idtext8,passphrase=Passphrase->Get(id8s,idtext8);
   if ((passphrase.IsEmpty() || ForceDialog) && !PGPGETSecretKeyPassphrase(ActMainForm,uids->Text,passphrase))
   {
      delete uids;
      delete id8s;
      delete msg;
      return NULL;
   }
   int result=16; // just a non-error number
   if (msg->buf->length)
   {
      TPgpDlg *Pgp = new TPgpDlg(PgpPublicRing(),PgpSecretRing(),PgpRemailRing(),ActMainForm);
      result = Pgp->DecryptMessage(msg->buf,passphrase);
      delete Pgp;
   }
   else
      MsgBoxHwnd(ActMainForm->Handle,"Nothing to decrypt!","PGP Decrypt Error",MB_OK);

   if (result==PGP_OK || result==PGP_SIGOK || result==PGP_SIGBAD || result==PGP_SIGNKEY)
   {
      if ((retbuf=new char[msg->buf->length+1])!=NULL)
         strcpy(retbuf,(char*)msg->buf->data);
      Passphrase->Add(idtext8,passphrase);
      ClearString(passphrase);
   }
   delete uids;
   delete id8s;
   delete msg;
   return retbuf;
}
//---------------------------------------------------------------------------
char* __fastcall PgpVerifyMessage(char *Message)
{
   if (retbuf) delete retbuf; retbuf = NULL;
   BUFFER *msg = buf_new(),*sig = buf_new();

   TStringList *detached,*armored;
   armored = new TStringList();
   detached = new TStringList();
   armored->SetText(Message);
   armored->Delete(0);
sm(armored->Text);
/*   if (armored->Count) armored->Delete(0);
   while(armored->Count && armored->Strings[0]!=BeginPgpSignature)
   {
      detached->Add(armored->Strings[0]);
      armored->Delete(0);
   }
   buf_sets(msg,armored->Text.c_str());
   buf_sets(sig,detached->Text.c_str());
*/
   buf_sets(msg,armored->Text.c_str());
   int result=16; // just a non-error number
   if (msg->length)
   {
      TPgpDlg *Pgp = new TPgpDlg(PgpPublicRing(),PgpSecretRing(),PgpRemailRing(),ActMainForm);
      result = Pgp->VerifyMessage(msg,sig);
      delete Pgp;
   }
   else
      MsgBoxHwnd(ActMainForm->Handle,"Nothing to decrypt!","PGP Decrypt Error",MB_OK);

   if (result==PGP_OK || result==PGP_SIGOK || result==PGP_SIGBAD || result==PGP_SIGNKEY)
   {
      if ((retbuf=new char[msg->length+1])!=NULL)
         strcpy(retbuf,(char*)msg->data);
   }

   buf_free(sig);
   buf_free(msg);
   return retbuf;
}
//---------------------------------------------------------------------------
bool __fastcall PgpGetEncryptList(TForm *Owner, TStrings *Recips, bool CanConv)
{
   bool ok=false;
   TPgpRecipDlg *pf = new TPgpRecipDlg(Owner,Recips,CanConv);
   if (pf->opendlg) pf->ShowModal();
   if (pf->ModalResult==mrOk || !pf->opendlg)
      ok = true;
   delete pf;
   return ok;
}
//---------------------------------------------------------------------------












