#define _WINSOCKAPI_
//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#include <time.h>
#pragma hdrstop

#include "SmtpDlgs.h"
#include "RemailerDlgs.h"
#include "Global.h"
#include "HeadMan.h"
#include "FileMan.h"
#include "PrintDlgs.h"
#include "MailboxWins.h"
#include "MailboxDlgs.h"
#include "MixKeyWins.h"
#include "Mixmaster.h"
#include "nymmail.h"
#include "WipeDlgs.h"
#include "PgpMail.h"
#include "Pool.h"
#include "ProThrd.h"
#include "view.h"

#pragma link "SmtpProt"
#pragma resource "*.dfm"
TSmtpDlg *SmtpDlg;
//---------------------------------------------------------------------------
bool __fastcall SendMail()
{
   if (UpdateStatsOnSend())
   {
      if (!GetRemailerStats(AppMainForm,false)) return false;
      Application->ProcessMessages(); Sleep(500);
   }

   SmtpDlg = new TSmtpDlg(AppMainForm);
   bool ok = SmtpDlg->Execute();
   delete SmtpDlg;

   if (!AppDataExists(MailQueue)) SetQueueHasChainMail(false);
   return ok;
}
//---------------------------------------------------------------------------
bool __fastcall UpdateStatsOnSend()
{
   return AppMainForm->Perform(WM_UPDATECHECKED,0,NULL)>0;
}
//---------------------------------------------------------------------------
void __fastcall SetQueueHasChainMail(bool state)
{
   PutAppIni(QueueHasChain,(state==true?"1":"0"));
}
//---------------------------------------------------------------------------
bool __fastcall QueueHasChainMail()
{
   return GetAppIni(QueueHasChain,"0")=="1";
}
//---------------------------------------------------------------------------
void __fastcall WrapMessage(TStrings *Message, int AtCol)
{
   AnsiString line;
   AnsiString qm = GetAppIni(QuoteMarks,"> ");
   bool notquoted = GetAppIni(DontWrapQuoted,"").ToIntDef(0);

   if (AtCol==-1)
   {
      AtCol = 0;
      line = Message->Strings[0];
      if (line.Pos(WordWrapHeader)==1)
      {

         AtCol = line.SubString(WordWrapHeader.Length()+1,16).ToIntDef(0);
         Message->Delete(0);
      }
   }
   bool inhead = true;
   TStringList *mail = new TStringList();
   while (Message->Count)
   {
      int col=AtCol;
      line = Message->Strings[0].TrimRight();
      if (inhead)
      {
         if (line.IsEmpty()) inhead = false;
         mail->Add(line);
      }
      else
      {
         if (line.Pos(qm)==1 && notquoted) col = 0;
         AddString(line,mail,col);
      }
      Message->Delete(0);
   }
   Message->Text = mail->Text;
   delete mail;
}
//---------------------------------------------------------------------------
void __fastcall AddString(AnsiString &String, TStrings *Strings, int WordWrapAt)
{
   AnsiString s=String;
   int wwAt=WordWrapAt,wwActual=wwAt-1;
   if (wwAt>0 && wwAt<16) wwAt = 16;
   while (wwAt>0 && s.Length()>wwAt)
   {
      for (int i=wwAt; i>0; i--)
         if (s[i]==' ' || s[i]=='-')
         {
            wwActual = i; break;
         }
      Strings->Add(s.SubString(1,wwActual));
      s = s.SubString(wwActual+1,4096);
   }
   Strings->Add(s);
}
//---------------------------------------------------------------------------
AnsiString __fastcall SMTPPOP3logtime()
{
   return FormatDateTime("mmm dd, yyyy hh:nn:ss (ddd)",Now());
}
//---------------------------------------------------------------------------
#define DISPLAY(msg) Display->Lines->Add(msg)
__fastcall TSmtpDlg::TSmtpDlg(TComponent* Owner)
	: TForm(Owner)
{
   // Center in Main Window
   TForm *Main = Application->MainForm;
   Top = Main->Top+((Main->Height-Height)/2);
   Left = Main->Left+((Main->Width-Width)/2);
   // initialize
   Application->OnException = ExceptionHandler;

   Messages = new TStringList();
   Messages->Sorted = true;
   GetAppData(Messages,MailQueue);
   Messages->Sorted = false;
   //if (!Messages->Count) return; // nothing to send...

   Message = new TStringList();
   HeadMan = new THeaderManager(Message);
   Head = new TStringList();
   Body = new TStringList();

   bak = new TStringList();
   ProblemRpt = new TStringList();
   LastMixFeedback = new TStringList();
   NymConfigNym = "";
   Cancelled = false;
   Aborted = false;
   InEHLO = false;

   LastError = 0;
   MimeMan = NULL;
   MixMan = NULL;
   Rset = false;
   curmsg = 0;
}
//---------------------------------------------------------------------------
__fastcall TSmtpDlg::~TSmtpDlg()
{
   MixPoolDeleteFile();
   delete LastMixFeedback;
   delete ProblemRpt;
   delete bak;
   delete Head;
   delete Body;
   delete HeadMan;
   delete Message;
   delete Messages;
}
//---------------------------------------------------------------------------
void __fastcall TSmtpDlg::FormShow(TObject *Sender)
{
   Cancelled = false;
   PostMessage(Handle,WM_NEXTMESSAGE,0,0L);
}
//---------------------------------------------------------------------------
int __fastcall TSmtpDlg::Execute()
{
   ShowModal(); return ModalResult;
}
//---------------------------------------------------------------------------
int __fastcall TSmtpDlg::GetHeaders()
{
   int count=0;
   Head->Clear();
   Body->Clear();
   bool inhead=true;
   if (Message!=NULL)
   {
      for (int i=0; i<Message->Count; i++)
      {
         AnsiString s = Message->Strings[i];
         if (s.IsEmpty() && inhead) inhead = false;
         else if (!inhead) Body->Add(s);
         else Head->Add(s);
      }
      while (Body->Count && Body->Strings[Body->Count-1].Trim().IsEmpty())
         Body->Delete(Body->Count-1);
      Body->Add("");
   }
   return count;
}
//---------------------------------------------------------------------------
void __fastcall AddDateHeader(TStrings *toHeaders)
{
   int pos=0; while(pos<toHeaders->Count)
   {
      if (toHeaders->Strings[pos].Pos("Date:")==1)
      {
         toHeaders->Delete(pos);
         break;
      }
      pos++;
   }
   toHeaders->Insert(pos,"Date: "+Rfc822DateTime(Now()));
}
//---------------------------------------------------------------------------
bool __fastcall TSmtpDlg::PrepareMail()
{
   AnsiString SignOn,FName,Host,Port;
   GetHeaders();
   BytesSent = 0;
   ProgressBar->Position = 0;
   BytesTotal = Body->Text.Length();

   Host = HeadMan->GetDat("Host: ",Head);
   if (Host.Pos(":")>1)
   {
      Port = GetParam(1,Host,":");
      Host = GetParam(0,Host,":");
   }
   SMTP->Host = Host;
   if (!Port.IsEmpty()) SMTP->Port = Port;

   FName = HeadMan->GetDat("From: ");
   SMTP->FromName = HeadMan->GetAddress(FName);

   if ((SignOn=HeadMan->GetDat("Sign-On: ",Head)).IsEmpty())
      SignOn = HeadMan->GetDomain(SMTP->FromName);
   SMTP->SignOn = SignOn;

   SMTP->HdrFrom = FName;
   SMTP->HdrSubject = HeadMan->GetDat("Subject: ");
   SMTP->HdrTo = HeadMan->GetDat("To: ");

   HeadMan->GetAttachments(SMTP->EmailFiles);
   HeadMan->GetRecipients(SMTP->RcptName);
   if (ADDDATEHEADER) AddDateHeader(Head);

   //handle special case nym-config
   if ((NymConfigNym=HeadMan->GetDat("Nym-Config: "))!="")
      HeadMan->Delete("Nym-Config: ");

   HeadMan->Delete("Sign-On: ");
   HeadMan->Delete("Host: ");
   HeadMan->Delete("Bcc: ");
   HeadMan->Delete("Fcc: ");
   return true;
}
//---------------------------------------------------------------------------
bool __fastcall TSmtpDlg::CutMessageAtMark()
{
   bool cut=false;
   if (Message->Text.Pos("\r\n"+CutMarks+"\r\n"))
   {
      for (int i=Message->Count-1; i>0; i--) // remove cutmarked portion of message
      {
         if (Message->Strings[i]==CutMarks)
         {
            while (Message->Count>i) Message->Delete(i);
            cut = true;
            break;
         }
      }
   }
   // remove all trailing empty lines and add a single one back;
   while (Message->Count && Message->Strings[Message->Count-1].Trim().IsEmpty())
      Message->Delete(Message->Count-1);
   Message->Add("");
   return cut;
}
//---------------------------------------------------------------------------
AnsiString __fastcall TSmtpDlg::GetMessageName()
{
   // returns the name of the last message not mixchain
   return !MessageNameOrg.IsEmpty() ? MessageNameOrg:MessageName;
}
//---------------------------------------------------------------------------
#define PB ProgressBar
long __fastcall TSmtpDlg::DoMixmasterMessage()
{
   int pos;
   AppProcessMessages();
   LastMixFeedback->Clear();
   LastMixDateTime = "";
   DISPLAY("Encountered mixmaster message");

   AppProcessMessages();
   ActiveControl = Panel1;
   AnsiString cap=Caption;
   for (int i=0; i<4; i++)
   {
      if (Caption.IsEmpty()) Caption = "Encrypting..."; else Caption = "";
      Sleep(300);
   }
   ActiveControl = Display;
   AppProcessMessages();

   Display->Cursor = crHourGlass;
   MixMan = new TMixMessage(Message,Display->Lines,ProgressBar,LastMixFeedback);
   int Result = MixMan->Execute();
   delete MixMan; MixMan=NULL;
   Display->Cursor = crDefault;
   Caption = cap;

   AnsiString fb = LastMixFeedback->Text;
   if ((pos=fb.Pos("Chain: "))>0)
   {
      fb.Delete(pos,7);
      LastMixFeedback->Text = fb;
   }
   LastMixCount = 0;

   if (!Cancelled)
   {
      Application->ProcessMessages();
      if (Result!=0)
      {
         PB->Visible = false;
         Abort();
      }
   }
   return Result;
}
//---------------------------------------------------------------------------
void __fastcall TSmtpDlg::MassageNewsgroupsAndReferencesAndSubject()
{
   int nidx,fidx,aidx;
   AnsiString ngrps,fgrps,arefs;
   HeadMan->HereIs(Message);
   // followup-to header
   fgrps = HeadMan->GetFollowupTo();
   fidx = HeadMan->Delete("Followup-To: ");
   if (!fgrps.IsEmpty() && fidx>=0) Message->Insert(fidx,"Followup-To: "+fgrps);
   // newsgroups header
   ngrps = HeadMan->GetNewsgroups();
   nidx = HeadMan->Delete("Newsgroups: ");
   if (!ngrps.IsEmpty() && nidx>=0) Message->Insert(nidx,"Newsgroups: "+ngrps);
   // references header
   arefs = HeadMan->GetReferences();
   aidx = HeadMan->Delete("References: ");
   if (!arefs.IsEmpty() && aidx>=0) Message->Insert(aidx,"References: "+arefs);
   // subject header
   AnsiString sub;
   TStringList *subject = new TStringList();
   subject->Text = HeadMan->GetDat("Subject: ");
   if (subject->Count>1)
   {
      sub = subject->Strings[0].Trim();
      for (int i=1; i<subject->Count; i++)
         sub += " "+subject->Strings[i].Trim();
      int pos = HeadMan->Delete("Subject: ");
      if (pos>=0) Message->Insert(pos,"Subject: "+sub);
      else
      {
         pos = HeadMan->IndexOf("To: ");
         Message->Insert(pos,"Subject: "+sub);
      }
   }
   delete subject;
}
//---------------------------------------------------------------------------
#define STRING(int) AnsiString(int)
bool __fastcall TSmtpDlg::GetNextMessage()
{
   if (!MixPoolCount() && !Messages->Count) return false;
   // setup for next message
   if (MixPoolCount())
   {
      TStringList *pool = new TStringList();
      if (MessageNameOrg.IsEmpty()) MessageNameOrg = MessageName;
      MixPoolGet(Message,MessageName,0);
      MixPoolDelete(0);
      delete pool;
   }
   else
   {
      MessageNameOrg = "";
      MessageName = Messages->Strings[0];
      GetAppData(Message,MailQueue+PS+MessageName);    // get from queue
      PutAppData(MailQueue+PS+MessageName,NULL);       // delete from queue
      PutAppData(ProblemQueue+PS+MessageName,Message); // store temporary in probs
      Messages->Delete(0);
   }
   THeaderManager *hm = new THeaderManager(Message);
   hm->Delete(ClrTextHdr);
   delete hm;

//MsgBoxHwnd(this,"GetNext","Test",MB_OK);//sm("GetNext");
//view(Message->Text);
   MassageNewsgroupsAndReferencesAndSubject();
   WrapMessage(Message,-1);
   CancelBtn->Enabled = true;
   ProblemRpt->Clear();
   NymConfigNym = "";
   HeadDone = false;
   BodyDone = false;
   return true;
}
//---------------------------------------------------------------------------
AnsiString __fastcall TSmtpDlg::SendingCurrentMessageString()
{
   TStrings *display=Display->Lines;
   AnsiString message,current,maximum;
   if (MessageName.Pos(MixmasterChain)==1) message = MessageName;
   else
   {
      current = AnsiString(++curmsg);
      maximum = AnsiString(Messages->Count+curmsg);
      message = "Sending Message "+current+" of "+maximum;
   }
   if (display->Count && !display->Strings[display->Count-1].IsEmpty())
      message = "\r\n" + message;
   return message;
}
//---------------------------------------------------------------------------
void __fastcall TSmtpDlg::GoNext()
{
   Message->Clear();
   PostMessage(Handle,WM_NEXTMESSAGE,0,0L);
}
//---------------------------------------------------------------------------
bool __fastcall TSmtpDlg::HasHeader(AnsiString &Header)
{
   return !HeadMan->GetDat(Header,Message).IsEmpty();
}
//---------------------------------------------------------------------------
bool __fastcall TSmtpDlg::DupleRemailers(AnsiString &keyring, AnsiString &typfile)
{
   int c;
   bool dups=false;
   AnsiString shrt;
   TStringList *shorts = new TStringList();
   TMixKeyList *keys=new TMixKeyList(keyring);
   TStringList *type=new TStringList();
   if (FileExists(typfile)) type->LoadFromFile(typfile);
   for (int i=0; i<keys->Count; i++)
   {
      shrt = keys->KeyShort(i);
      c = shorts->Values[shrt].ToIntDef(0);
      shorts->Values[shrt] = s(c+1);
      for (int t=0; t<type->Count; t++)
      {
         if (type->Strings[t]=="#"+keys->CrtDesc(i))
         {
            c = shorts->Values[shrt].ToIntDef(0);
            shorts->Values[shrt] = s(c-1);
            break;
         }
      }
   }
   for (int i=0; i<shorts->Count; i++)
   {
      c = shorts->Values[shorts->Names[i]].ToIntDef(0);
      if (c>1)
      {
         MsgBoxHwnd(Handle,
            s("You have "+s(c)+" duplicate keys for remailer '"+shorts->Names[i]+"'.\r\n")+
            s("You'll need to disable "+s(c-1)+" of these before\r\n")+
            s("you can continue with this send."),
            s("Remailer Key Error"),
            MB_OK
         );
         dups = true;
         break;
      }
   }
   //view(shorts);
   delete type;
   delete keys;
   delete shorts;
   return dups;
}
//---------------------------------------------------------------------------
void __fastcall TSmtpDlg::DoSendMessage()
{
   if (Cancelled) return;
   if (!GetNextMessage()) { Abort(); ShowExitInfo(); return; }

   DISPLAY(SendingCurrentMessageString());
   CutMessageAtMark();

   if (HasHeader("Attachment: ") && !AttachFiles(Message,Display->Lines,ProgressBar))
   {
      GoNext(); return;
   }
   if (Cancelled) return;
   if (HasHeader("Chain: "))
   {
      if (DupleRemailers(mringtxt,mtyp2txt)) { Abort(); return; }
      if (DoMixmasterMessage()!=0) Abort(); else GoNext();
      return;
   }
   if (Cancelled) return;
   if (!PrepareMail()) { GoNext(); return; }

   DISPLAY("Connecting...");
   SMTP->Connect();
}
//---------------------------------------------------------------------------
void __fastcall TSmtpDlg::WMNextMessage(TMessage& Msg)
{
   LastError=0; DoSendMessage();
}
//---------------------------------------------------------------------------
void __fastcall TSmtpDlg::ReturnCurrentToQueue()
{
   TStringList *msg = new TStringList();
   if (AppDataExists(ProblemQueue+PS+GetMessageName(),msg) && ProblemRpt->Count==0)
   {
      PutAppData(MailQueue+PS+GetMessageName(),msg);
      PutAppData(ProblemQueue+PS+GetMessageName(),NULL);
   }
   delete msg;
}
//---------------------------------------------------------------------------
void __fastcall TSmtpDlg::Except(Exception *E)
{
   AnsiString ExceptionError = "Exception: "+E->Message;
   ProblemRpt->Add(ExceptionError);
   DISPLAY(ExceptionError);
   DISPLAY("Aborting...");

   MixPoolDeleteFile();
   SaveProblemMessage(MessageName,ProblemRpt);
   if (MimeMan) MimeMan->Cancelled = true;
   if (MixMan) MixMan->Cancelled = true;
   ProgressBar->Visible = false;
   CancelBtn->Caption = Shit;
   Cancelled = true;
   Excepted = true;
   Aborted = true;
   SMTP->Abort();
}
//---------------------------------------------------------------------------
void __fastcall TSmtpDlg::Abort(WORD Error)
{
   if (Cancelled) return;
   if (Error)
   {
      AnsiString WinsockError =
         "Winsock Error: "+AnsiString(Error)+" "+WSocketErrorDesc(Error);
      AnsiString SmtpError = SMTP->ErrorMessage;
      if (SmtpError.IsEmpty()) SmtpError = "Not an SMTP error";
      ProblemRpt->Add("SMTP Error: "+SmtpError);
      ProblemRpt->Add(WinsockError);
      DISPLAY(WinsockError);
   }
   DISPLAY("Aborting...");

   MixPoolDeleteFile();
   SaveProblemMessage(GetMessageName(),ProblemRpt);
   if (MimeMan) MimeMan->Cancelled = true;
   if (MixMan) MixMan->Cancelled = true;
   ProgressBar->Visible = false;
   CancelBtn->Caption = Shit;
   Cancelled = true;
   Aborted = true;
   SMTP->Abort();
}
//---------------------------------------------------------------------------
void __fastcall TSmtpDlg::Cancel()
{
   MixPoolDeleteFile();
   if (!Display->Lines->Strings[Display->Lines->Count-1].IsEmpty())
      DISPLAY("");
   DISPLAY("Send cancelled by user!");
   if (MimeMan)
   {
      MimeMan->Cancelled = true;
      //ReturnCurrentToQueue();
      //ShowExitInfo();
   }
   if (MixMan)
   {
      MixMan->Cancelled = true;
      //ReturnCurrentToQueue();
      //ShowExitInfo();
   }
   SMTP->Abort();
   if (Display->Lines->Text.Pos("Session finished")==0)
   {
      //ReturnCurrentToQueue();
      //ShowExitInfo();
   }
   ProgressBar->Visible = false;
   CancelBtn->Caption = "Close";
   Cancelled = true;
}
//---------------------------------------------------------------------------
void __fastcall TSmtpDlg::CancelBtnClick(TObject *Sender)
{
   if (CancelBtn->Caption=="Close" || CancelBtn->Caption==Shit)
   {
      ModalResult = LastError || Cancelled ? mrCancel:mrOk;
      return;
   }
   if (CancelBtn->Caption=="Cancel")
   {
      if (BytesSent!=BytesTotal) Cancel();
      TapQueues();
   }
   ActiveControl = Display;
}
//---------------------------------------------------------------------------
void __fastcall TSmtpDlg::FormCloseQuery(TObject *Sender, bool &CanClose)
{
   if (CancelBtn->Caption=="Cancel")
   {
      CancelBtn->Click(); MyBeep(MB_OK); CanClose = false;
      Messages->Clear();
      return;
   }
   SaveSMTPlog();
   TapQueues();
}
//---------------------------------------------------------------------------
void __fastcall TSmtpDlg::ShowExitInfo()
{
   AnsiString S;
   int msgs=0,probs=0;
   CancelBtn->Enabled = true;
   TStringList *msg = new TStringList();
   if (AppDataExists(ProblemQueue,msg))
   {
      MyBeep(MB_ICONHAND);
      S = msg->Count>1 ? "s":"";
      DISPLAY("ERROR: "+AnsiString(msg->Count)+" unsent message"+S+" in PROBLEM Queue!");
      probs = msg->Count;
   }
   if (AppDataExists(MailQueue,msg))
   {
      S = msg->Count>1 ? "s":"";
      DISPLAY(AnsiString(msg->Count)+" unsent message"+S+" in Mail Queue!");
      msgs = msg->Count;
   }
   if (!msgs && !probs)
   {
      if (!AppMainForm->MDIChildCount) QSPoolClear();
      DISPLAY("All mail sent");
   }
   CancelBtn->Caption = SMTP->ErrorMessage.IsEmpty() ? AnsiString("Close"):Shit;
   DISPLAY("Session finished");
   TapQueues();
   delete msg;
}
//---------------------------------------------------------------------------
void __fastcall TSmtpDlg::ExceptionHandler(TObject *Sender, Exception *E)
{
   Except(E);
   ShowExitInfo();
}
//---------------------------------------------------------------------------
void __fastcall TSmtpDlg::SMTPDisplay(TObject *Sender, AnsiString Msg)
{
   TStrings *lines = Display->Lines;
   if (lines->Count && lines->Strings[lines->Count-1].Pos(" Connecting...")==1)
       lines->Add(" Connected to "+SMTP->Host);

   if (Msg.SubString(1,1)=="<") lines->Add(Msg.SubString(2,255));
}
//---------------------------------------------------------------------------
void __fastcall TSmtpDlg::SMTPGetData(TObject *Sender, int LineNum,
	PChar MsgLine, int MaxLen, bool &More)
{
   HeadDone = true;
   ProgressBar->Position = (WORD)(BytesSent/BytesTotal*100);
   Application->ProcessMessages();

   if (LineNum>Body->Count)
   {
      BodyDone = true;
      More = false;
      return;
   }
   // test for lines longer than maxlen
   int wwAt=MaxLen;
   AnsiString line=Body->Strings[LineNum-1];
   if (line.Length()>MaxLen)
   {
      for (int i=MaxLen; i>0; i--)
         if (line[i]==' ' || line[i]=='-')
         {
            wwAt=i;
            break;
         }

      if (LineNum==Body->Count) Body->Add(line.SubString(wwAt+1,10240000));
      else Body->Insert(LineNum,line.SubString(wwAt+1,10240000));
      line = line.SubString(1,wwAt);
   }
   
   strcpy(MsgLine,line.c_str());
   BytesSent += line.Length()+2;
}
//---------------------------------------------------------------------------
/*void __fastcall TSmtpDlg::SMTPRequestDone(TObject *Sender, TSmtpRequest RqType,
   WORD Error)
{
   if (Error)
   {
      Abort(Error);
      return;
   }
   switch (RqType)
   {
      case smtpConnect: SMTP->Helo(); break;
      case smtpHelo: SMTP->MailFrom(); break;
      case smtpMailFrom: SMTP->RcptTo(); break;
      case smtpRcptTo:
         ProgressBar->Visible = true;
         SMTP->Data();
         break;
      case smtpRset:
      case smtpData:
         SMTP->Quit();
         break;
      case smtpQuit:
         ProgressBar->Visible = false;
         if (SMTP->Host.LowerCase().Pos(".netzero.net")>0)
             SMTP->WSocket->Close();
         break;
   }
}*/
//---------------------------------------------------------------------------
bool __fastcall TSmtpDlg::NeedsSMTPAuthentication(AnsiString host, AnsiString &userid,
   AnsiString &password)
{
   TStringList *hosts = new TStringList();
   GetAppData(hosts,SMTPAuthenticHosts);
   AnsiString data = hosts->Values[host];
   password = GetToken(1,data,"\255");
   userid = GetToken(0,data,"\255");
   delete hosts;
   return !data.IsEmpty();
}
//---------------------------------------------------------------------------
bool __fastcall TSmtpDlg::HasAUTHCommand(AnsiString &Mechanism)
{
   AnsiString mech;
   for (int i=0; i<Display->Lines->Count; i++)
   {
      AnsiString line = Display->Lines->Strings[i].Trim().UpperCase();
      if (line.Trim().Pos("250-AUTH=")==1 || line.Trim().Pos("250 AUTH=")==1)
      {
         mech = line.SubString(10,64);
         break;
      }
   }
   if (mech.IsEmpty()) Display->Lines->Add(
      "Host does not support authenticated login.\nTrying unauthenticated...");
   else Mechanism = mech;
   return !mech.IsEmpty();
}
//---------------------------------------------------------------------------
void __fastcall TSmtpDlg::SMTPRequestDone(TObject *Sender, TSmtpRequest RqType,
   WORD Error)
{
   if (Error)
   {
      if (InEHLO)
      {
         InEHLO = false;
         SMTP->Helo();
         return;
      }
      Abort(Error);
      return;
   }
   AnsiString userid,passwd,authmech;
   switch (RqType)
   {
      case smtpConnect:
         if (NeedsSMTPAuthentication(SMTP->Host,userid,passwd))
         {
            InEHLO = true;
            SMTP->AuthUserId = userid;
            SMTP->AuthPassWd = passwd;
            SMTP->Ehlo();
         }
         else SMTP->Helo();
         break;
      case smtpEhlo:
         InEHLO = false;
         if (HasAUTHCommand(authmech))
         {
            SMTP->AuthMechanism = authmech;
            SMTP->Auth();
         }
         else SMTP->MailFrom();
         break;
      case smtpAuth: SMTP->UserId(); break;
      case smtpUserId: SMTP->PassWd(); break;
      case smtpPassWd:
      case smtpHelo: SMTP->MailFrom(); break;
      case smtpMailFrom: SMTP->RcptTo(); break;
      case smtpRcptTo:
         ProgressBar->Visible = true;
         SMTP->Data();
         break;
      case smtpRset:
      case smtpData:
         SMTP->Quit();
         break;
      case smtpQuit:
         ProgressBar->Visible = false;
         if (SMTP->Host.LowerCase().Pos(".netzero.net")>0)
             SMTP->WSocket->Close();
         break;
   }
}
//---------------------------------------------------------------------------
void __fastcall TSmtpDlg::SMTPProcessHeader(TObject *Sender,
	TStrings *HdrLines)
{
   HdrLines->Text = Head->Text;
}
//---------------------------------------------------------------------------
void __fastcall TSmtpDlg::FileCopyMail(AnsiString &ToMailbox,TStrings* Message)
{
   if (!MailboxExists(ToMailbox)) CreateMailbox(ToMailbox);
   // save the message
   PutAppData(UserMailboxes+PS+ToMailbox+PS+HeadMan->IndexString(Message),Message);
   // refresh index if it is open
   if ((MailboxWin=FindOpenMailbox(ToMailbox))!=NULL)
      MailboxWin->MailGrid->RefreshIndex();
}
//---------------------------------------------------------------------------
void __fastcall TSmtpDlg::SMTPSessionClosed(TObject *Sender, WORD Error)
{
   int clrtxt;
   AnsiString IdxStr,CntStr;
   DISPLAY("Connection closed!\r\n");
   if (Error)
   {
      AnsiString WinsockError =
         "Winsock Error: "+AnsiString(Error)+" "+WSocketErrorDesc(Error);
      AnsiString SmtpError = SMTP->ErrorMessage;
      if (SmtpError.IsEmpty()) SmtpError = "Not an SMTP error";

      ProblemRpt->Add("SMTP Error: "+SmtpError);
      ProblemRpt->Add(WinsockError);
      DISPLAY(WinsockError);
   }
   if (BytesSent==BytesTotal)
   {
      bool isChain = MessageName.Pos(MixmasterChain)==1;
      if (isChain && LastMixFeedback->Count)
      {
         LastMixCount++;
         int count=LastMixFeedback->Count;
         TStringList *msg = new TStringList();
         TStringList *log = new TStringList();
         GetAppData(msg,ProblemQueue+PS+GetMessageName());
         CntStr = count>1 ? s("   "+s(LastMixCount)+") "):s("   ");
         if (LastMixDateTime.IsEmpty()) LastMixDateTime = HeadMan->DateTimeOut();
         IdxStr = LastMixDateTime+" "+HeadMan->GetDat("Subject: ",msg)+"                                                  ";
         IdxStr = IdxStr.SubString(1,53)+CntStr+LastMixFeedback->Strings[LastMixCount-1].Trim();
         GetAppData(log,ChainLog); log->Add(IdxStr);
         int max=GetAppIni(ChainLogMax,"").ToIntDef(16);
         while (max && log->Count>max)
            log->Delete(0);
         PutAppData(ChainLog,log);
         delete log;
         delete msg;
      }
      // if it is not a chain, do it
      // if it is a chain and also last in pool, do it
      // if it is chain and not last in pool, don't do it
      if (!isChain || (isChain && !MixPoolCount()))
      {
         TStringList *msg = new TStringList();
         TStringList *replay = new TStringList();
         GetAppData(msg,ProblemQueue+PS+GetMessageName());
         AnsiString Fcc = HeadMan->GetDat("Fcc: ",msg);
         HeadMan->Delete(WordWrapHeader,msg);
         if ((clrtxt=QSPoolHeaderToClearText(msg))>0)
         {
            replay->Text = msg->Text;
            QSPoolGet(msg,clrtxt);
         }
         if (!Fcc.IsEmpty())
         {
            HeadMan->Delete("Date: ");
            FileCopyMail(Fcc,msg);
         }
         if (NymConfigNym.IsEmpty()) NymConfigNym = HeadMan->GetDat("Nym-Config: ",msg);
         if(!NymConfigNym.IsEmpty())
         {
            PutAppData(NymReplaysKey+PS+NymConfigNym,replay);
            PutAppData(NymConfigsKey+PS+NymConfigNym,msg);
         }
         PutAppData(ProblemQueue+PS+GetMessageName(),NULL);
         delete replay;
         delete msg;
      }
      NymConfigNym = "";
   }
   else // there may be a problem
   {
      if (!Aborted && !ProblemRpt->Count) ReturnCurrentToQueue();
      else SaveProblemMessage(GetMessageName(),ProblemRpt);
   }
   if (!Cancelled && (Messages->Count || MixPoolCount()))
   {
      PostMessage(Handle,WM_NEXTMESSAGE,0,0L); return;
   }
   ShowExitInfo();
}
//---------------------------------------------------------------------------
void __fastcall TSmtpDlg::SaveProblemMessage(AnsiString MsgName, TStrings *Problems)
{
   int p,index;
   AnsiString s;//=Problems->Text; Problems->Text=s;
   TStringList *msg = new TStringList();
   TStringList *probs = new TStringList();
   for (int i=0; i<Problems->Count; i++)
   {
      s = Problems->Strings[i].TrimRight();
      while ((p=s.Pos("\r"))>0) s.Delete(p,1);
      while ((p=s.Pos("\n"))>0) s.Delete(p,1);
      AddString(s,probs,50);
      probs->Add("");
   }
   GetAppData(msg,ProblemQueue+PS+MsgName);
   if (!msg->Count) msg->Add("");
   // handle special headers
   THeaderManager *hm = new THeaderManager(msg);
   if ((index=hm->IndexOf(WordWrapHeader))>=0) msg->Delete(index);
   if (msg->Count)
   {
      int idx=0;
      msg->Insert(idx++,"######################################################");
      msg->Insert(idx++,"#");
      for (int i=0; i<probs->Count; i++)
         msg->Insert(idx++,"#  "+probs->Strings[i]);
      msg->Insert(idx++,"#");
   }
   PutAppData(ProblemQueue+PS+MsgName,msg);
   Problems->Clear();
   delete probs;
   delete msg;
}
//---------------------------------------------------------------------------
void __fastcall TSmtpDlg::PopPrintItemClick(TObject *Sender)
{
   if (MsgBoxHwnd(Handle,"Send this transcript to the printer?","Confirm",MB_OKCANCEL)==IDOK)
     PrintMessage(Display->Lines,Display->Font,"QuickSilver SMTP Transcript",this);
}
//---------------------------------------------------------------------------
void __fastcall TSmtpDlg::TapQueues()
{
   Application->MainForm->Perform(WM_PROBLEMCHANGE,0,NULL);
   Application->MainForm->Perform(WM_QUEUECHANGE,0,NULL);
}
//---------------------------------------------------------------------------
void __fastcall TSmtpDlg::SaveSMTPlog()
{
   TStringList *list = new TStringList();
   GetAppData(list,SMTPLog);
   int max = GetAppIni(SMTPLogMax,"").ToIntDef(16);
   while (max && list->Count>=max)
   {
      PutAppData(SMTPLog+PS+list->Strings[0],NULL);
      list->Delete(0);
   }
   AnsiString logstr = SMTPPOP3logtime();
   if (Display->Lines->Text.Pos("All mail sent"))
      logstr += " All mail sent";
   else
   if (Display->Lines->Text.Pos("Aborting..."))
      logstr += " Error: send aborted";
   else
   if (Display->Lines->Text.Pos("Send cancelled by user!"))
      logstr += " Send cancelled by user";
   PutAppData(SMTPLog+PS+logstr,Display->Lines);
   delete list;
}
//---------------------------------------------------------------------------
void __fastcall TSmtpDlg::SetEditRect()
{
   TRect Rct = Rect(3,0,Display->ClientWidth-8,ClientHeight);
   Display->Perform(EM_SETRECT,0,long(&Rct));
}
//---------------------------------------------------------------------------
void __fastcall TSmtpDlg::FormResize(TObject *Sender)
{
   CancelBtn->Left = Width-141;
   ProgressBar->Width = Width-172;
   SetEditRect();
}
//---------------------------------------------------------------------------
void __fastcall TSmtpDlg::FormPaint(TObject *Sender)
{
   SetEditRect();
}
//---------------------------------------------------------------------------
void __fastcall TSmtpDlg::Timer2Timer(TObject *Sender)
{
   if (ProgressBar->Position<100) ProgressBar->Position += (WORD)1;
   else ProgressBar->Position = 20;
}
//---------------------------------------------------------------------------
void __fastcall TSmtpDlg::PopCopyItemClick(TObject *Sender)
{
   Display->CopyToClipboard();
}
//---------------------------------------------------------------------------
void __fastcall TSmtpDlg::PopupMenu1Popup(TObject *Sender)
{
   PopCopyItem->Enabled = Display->SelLength>0;
}
//---------------------------------------------------------------------------
